SystemOrganization addCategory: #AlienLoader!

Object subclass: #AlienLoader
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AlienLoader'!

!AlienLoader class methodsFor: 'loading' stamp: 'FernandoOlivero 8/27/2009 14:42'!
allFor: config
	self validateLoading.
	config project: 'Alien' dependsOn: [  
		config package: 'Alien-Core' from: 'http://www.squeaksource.com/Alien'.
		config package: 'Alien-CoreTest' from: 'http://www.squeaksource.com/Alien'.
		config package: 'Alien-Examples' from: 'http://www.squeaksource.com/Alien' ].
	! !

!AlienLoader class methodsFor: 'loading' stamp: 'FernandoOlivero 8/27/2009 14:37'!
ensureFlairAndGofer
	Smalltalk at: #FLProject ifAbsent: [
		ScriptLoader  loadLatestPackage: 'Gofer' from: 'http://source.lukas-renggli.ch/flair'.
		ScriptLoader  loadLatestPackage: 'Flair' from: 'http://source.lukas-renggli.ch/flair'. ].! !

!AlienLoader class methodsFor: 'loading' stamp: 'FernandoOlivero 8/27/2009 14:43'!
load
	| config |
	self validateLoading. 
	self ensureFlairAndGofer.
	config := (Smalltalk at: #FLConfiguration) new.
	self allFor: config.
	config load.
	self postInstall ! !

!AlienLoader class methodsFor: 'loading' stamp: 'F Oliver 5/13/2009 19:08'!
loadLibCInPharo
	"
	self loadLibCInPharo 
	"
	| instClass |
	instClass := self environment at: #Installer ifAbsent: [ScriptLoader new installingInstaller].
	instClass ss project: 'Alien'; install: 'Alien-LibC'.! !

!AlienLoader class methodsFor: 'loading' stamp: 'F Oliver 5/13/2009 19:22'!
loadWin32InPharo
	"
	self  loadWin32InPharo
	"
	| instClass |
	instClass := self environment at: #Installer ifAbsent: [ScriptLoader new installingInstaller].
	instClass ss project: 'Alien'; install: 'Alien-Win32'.! !

!AlienLoader class methodsFor: 'loading' stamp: 'F Olivero 5/19/2009 20:16'!
postInstall
	ParseNode initialize.
	Alien initialize.
	AlienLibrary initialize.
	FFICallbackThunk initialize.
	Callback initialize.
	UnsafeAlien initialize.	! !

!AlienLoader class methodsFor: 'loading' stamp: 'FernandoOlivero 8/27/2009 14:41'!
validateLoading 
	"(Smalltalk specialObjectsArray size = 50) not ifTrue:[ ^ self error: 'This version of ALIEN assumes a size of 50 in the array of special objects, if loaded would cause the image to crash!!. Please contact the Alien package developers'].
	"! !
